Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.axis.encoding
Class DeserializationContextImpl

    java.lang.Object
      |
      +--org.xml.sax.helpers.DefaultHandler
            |
            +--org.apache.axis.encoding.DeserializationContextImpl

All Implemented Interfaces:
  org.xml.sax.ContentHandler, DeserializationContext, DeserializationContext, org.xml.sax.DTDHandler, org.xml.sax.EntityResolver, org.xml.sax.ErrorHandler, org.xml.sax.ext.LexicalHandler

public class DeserializationContextImpl
extends org.xml.sax.helpers.DefaultHandler
implements org.xml.sax.ext.LexicalHandler, DeserializationContext

Author:
  Glen Daniels (gdaniels@macromedia.com) Re-architected for JAX-RPC Compliance by:, Rich Scheuerle (scheu@us.ibm.com)

Field Summary
`protected org.xml.sax.InputSource` | `inputSource`
`protected static org.apache.commons.logging.Log` | `log`
`protected MessageContext` | `msgContext`
`protected int` | `startOfMappingsPos`

Constructor Summary
`DeserializationContextImpl(org.xml.sax.InputSource is, MessageContext ctx, java.lang.String messageType)` Construct Deserializer
`DeserializationContextImpl(org.xml.sax.InputSource is, MessageContext ctx, java.lang.String messageType, SOAPEnvelope env)` Construct Deserializer
`DeserializationContextImpl(MessageContext ctx, SOAPHandler initialHandler)` Construct Deserializer using MessageContext and EnvelopeBuilder handler

Method Summary
`void` | `addObjectById(java.lang.String id, java.lang.Object obj)` Add the object associated with this id (where id is the value of an id= attribute, i.e.
`void` | `characters(char[] p1, int p2, int p3)`
`void` | `comment(char[] ch, int start, int length)`
`void` | `endCDATA()`
`void` | `endDocument()` endDocument is invoked at the end of the document.
`void` | `endDTD()`
`void` | `endElement(java.lang.String namespace, java.lang.String localName, java.lang.String qName)` endElement is called at the end tag of an element
`void` | `endEntity(java.lang.String name)`
`void` | `endPrefixMapping(java.lang.String prefix)`
`MessageElement` | `getCurElement()` Get current MessageElement
`java.util.ArrayList` | `getCurrentNSMappings()` Get the Namespace Mappings.
`int` | `getCurrentRecordPos()` Get the current position in the record.
`Deserializer` | `getDeserializer(java.lang.Class cls, QName xmlType)` Get a Deserializer which can turn a given xml type into a given Java type
`Deserializer` | `getDeserializerForType(QName xmlType)` Convenience method to get the Deserializer for a specific xmlType.
`org.xml.sax.Locator` | `getDocumentLocator()`
`MessageElement` | `getElementByID(java.lang.String id)` Get the MessageElement for the indicated id (where id is the #value of an href) If the MessageElement has not been processed, the MessageElement will be returned.
`SOAPEnvelope` | `getEnvelope()` Get Envelope
`MessageContext` | `getMessageContext()` Get MessageContext
`java.lang.String` | `getNamespaceURI(java.lang.String prefix)` Get the Namespace for a particular prefix
`java.lang.Object` | `getObjectByRef(java.lang.String href)` Gets the MessageElement or actual Object value associated with the href value.
`QName` | `getQNameFromString(java.lang.String qNameStr)` Construct a QName from a string of the form :
`SAX2EventRecorder` | `getRecorder()` Get Event Recorder
`int` | `getStartOfMappingsPos()` Get the start of the mapping position
`QName` | `getTypeFromAttributes(java.lang.String namespace, java.lang.String localName, org.xml.sax.Attributes attrs)` Create a QName for the type of the element defined by localName and namespace with the specified attributes.
`QName` | `getTypeFromXSITypeAttr(java.lang.String namespace, java.lang.String localName, org.xml.sax.Attributes attrs)` Create a QName for the type of the element defined by localName and namespace from the XSI type.
`TypeMapping` | `getTypeMapping()` Get the TypeMapping for this DeserializationContext
`TypeMappingRegistry` | `getTypeMappingRegistry()` Get the TypeMappingRegistry we're using.
`void` | `ignorableWhitespace(char[] p1, int p2, int p3)`
`boolean` | `isDoneParsing()` Return if done parsing document.
`boolean` | `isNil(org.xml.sax.Attributes attrs)` Convenenience method that returns true if the value is nil (due to the xsi:nil) attribute.
`void` | `parse()` Create a parser and parse the inputSource
`SOAPHandler` | `popElementHandler()`
`void` | `processingInstruction(java.lang.String p1, java.lang.String p2)`
`void` | `pushElementHandler(SOAPHandler handler)` Management of sub-handlers (deserializers)
`void` | `pushNewElement(MessageElement elem)` Push the MessageElement into the recorder
`void` | `registerElementByID(java.lang.String id, MessageElement elem)` Register the MessageElement with this id (where id is id= form without the #) This routine is called when the MessageElement with an id is read.
`void` | `registerFixup(java.lang.String href, Deserializer dser)` During deserialization, an element with an href=#id may be encountered before the element defining id=id is read.
`void` | `registerResolverForID(java.lang.String id, IDResolver resolver)` Each id can have its own kind of resolver.
`void` | `replaceElementHandler(SOAPHandler handler)` Replace the handler at the top of the stack.
`void` | `setCurElement(MessageElement el)` Set current MessageElement
`void` | `setDocumentLocator(org.xml.sax.Locator locator)`
`void` | `setRecorder(SAX2EventRecorder recorder)` Set Event Recorder
`void` | `skippedEntity(java.lang.String p1)`
`void` | `startCDATA()`
`void` | `startDocument()` SAX event handlers
`void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)`
`void` | `startElement(java.lang.String namespace, java.lang.String localName, java.lang.String qName, org.xml.sax.Attributes attributes)` startElement is called when an element is read.
`void` | `startEntity(java.lang.String name)`
`void` | `startPrefixMapping(java.lang.String prefix, java.lang.String uri)` Record the current set of prefix mappings in the nsMappings table.

Methods inherited from class org.xml.sax.helpers.DefaultHandler
`error, fatalError, notationDecl, resolveEntity, unparsedEntityDecl, warning`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### log

    protected static org.apache.commons.logging.Log log

### msgContext

    protected MessageContext msgContext

### inputSource

    protected org.xml.sax.InputSource inputSource

### startOfMappingsPos

    protected int startOfMappingsPos

Constructor Detail

### DeserializationContextImpl

    public DeserializationContextImpl(MessageContext ctx,
                                      SOAPHandler initialHandler)

  Construct Deserializer using MessageContext and EnvelopeBuilder handler
  Parameters:
    `ctx` - is the MessageContext
    `initialHandler` - is the EnvelopeBuilder handler

### DeserializationContextImpl

    public DeserializationContextImpl(org.xml.sax.InputSource is,
                                      MessageContext ctx,
                                      java.lang.String messageType)

  Construct Deserializer
  Parameters:
    `is` - is the InputSource
    `ctx` - is the MessageContext
    `messageType` - is the MessageType to construct an EnvelopeBuilder

### DeserializationContextImpl

    public DeserializationContextImpl(org.xml.sax.InputSource is,
                                      MessageContext ctx,
                                      java.lang.String messageType,
                                      SOAPEnvelope env)

  Construct Deserializer
  Parameters:
    `is` - is the InputSource
    `ctx` - is the MessageContext
    `messageType` - is the MessageType to construct an EnvelopeBuilder
    `env` - is the SOAPEnvelope to construct an EnvelopeBuilder

Method Detail

### parse

    public void parse()
               throws org.xml.sax.SAXException

  Create a parser and parse the inputSource
  Specified by:
    `parse` in interface `DeserializationContext`

### getCurElement

    public MessageElement getCurElement()

  Get current MessageElement
  Specified by:
    `getCurElement` in interface `DeserializationContext`

### setCurElement

    public void setCurElement(MessageElement el)

  Set current MessageElement
  Specified by:
    `setCurElement` in interface `DeserializationContext`

### getMessageContext

    public MessageContext getMessageContext()

  Get MessageContext
  Specified by:
    `getMessageContext` in interface `DeserializationContext`

### getEnvelope

    public SOAPEnvelope getEnvelope()

  Get Envelope
  Specified by:
    `getEnvelope` in interface `DeserializationContext`

### getRecorder

    public SAX2EventRecorder getRecorder()

  Get Event Recorder
  Specified by:
    `getRecorder` in interface `DeserializationContext`

### setRecorder

    public void setRecorder(SAX2EventRecorder recorder)

  Set Event Recorder
  Specified by:
    `setRecorder` in interface `DeserializationContext`

### getCurrentNSMappings

    public java.util.ArrayList getCurrentNSMappings()

  Get the Namespace Mappings. Returns null if none are present.
  Specified by:
    `getCurrentNSMappings` in interface `DeserializationContext`

### getNamespaceURI

    public java.lang.String getNamespaceURI(java.lang.String prefix)

  Get the Namespace for a particular prefix
  Specified by:
    `getNamespaceURI` in interface `DeserializationContext`

### getQNameFromString

    public QName getQNameFromString(java.lang.String qNameStr)

  Construct a QName from a string of the form :
  Specified by:
    `getQNameFromString` in interface `DeserializationContext`
  Parameters:
    `qNameStr` - is the prefixed name from the xml text
  Returns:
    QName

### getTypeFromXSITypeAttr

    public QName getTypeFromXSITypeAttr(java.lang.String namespace,
                                        java.lang.String localName,
                                        org.xml.sax.Attributes attrs)

  Create a QName for the type of the element defined by localName and namespace from the XSI type.
  Specified by:
    `getTypeFromXSITypeAttr` in interface `DeserializationContext`
  Parameters:
    `namespace` - of the element
    `localName` - is the local name of the element
    `attrs` - are the attributes on the element

### getTypeFromAttributes

    public QName getTypeFromAttributes(java.lang.String namespace,
                                       java.lang.String localName,
                                       org.xml.sax.Attributes attrs)

  Create a QName for the type of the element defined by localName and namespace with the specified attributes.
  Specified by:
    `getTypeFromAttributes` in interface `DeserializationContext`
  Parameters:
    `namespace` - of the element
    `localName` - is the local name of the element
    `attrs` - are the attributes on the element

### isNil

    public boolean isNil(org.xml.sax.Attributes attrs)

  Convenenience method that returns true if the value is nil (due to the xsi:nil) attribute.
  Specified by:
    `isNil` in interface `DeserializationContext`
  Parameters:
    `attrs` - are the element attributes.
  Returns:
    true if xsi:nil is true

### getDeserializer

    public final Deserializer getDeserializer(java.lang.Class cls,
                                              QName xmlType)

  Get a Deserializer which can turn a given xml type into a given Java type
  Specified by:
    `getDeserializer` in interface `DeserializationContext`

### getDeserializerForType

    public final Deserializer getDeserializerForType(QName xmlType)

  Convenience method to get the Deserializer for a specific xmlType.
  Specified by:
    `getDeserializerForType` in interface `DeserializationContext`
  Parameters:
    `xmlType` - is QName for a type to deserialize
  Returns:
    Deserializer

### getTypeMapping

    public TypeMapping getTypeMapping()

  Get the TypeMapping for this DeserializationContext
  Specified by:
    `getTypeMapping` in interface `DeserializationContext`

### getTypeMappingRegistry

    public TypeMappingRegistry getTypeMappingRegistry()

  Get the TypeMappingRegistry we're using.
  Specified by:
    `getTypeMappingRegistry` in interface `DeserializationContext`
  Returns:
    TypeMapping or null

### getElementByID

    public MessageElement getElementByID(java.lang.String id)

  Get the MessageElement for the indicated id (where id is the #value of an href) If the MessageElement has not been processed, the MessageElement will be returned. If the MessageElement has been processed, the actual object value is stored with the id and this routine will return null.
  Specified by:
    `getElementByID` in interface `DeserializationContext`
  Parameters:
    `id` - is the value of an href attribute
  Returns:
    MessageElement or null

### getObjectByRef

    public java.lang.Object getObjectByRef(java.lang.String href)

  Gets the MessageElement or actual Object value associated with the href value. The return of a MessageElement indicates that the referenced element has not been processed. If it is not a MessageElement, the Object is the actual deserialized value. In addition, this method is invoked to get Object values via Attachments.
  Specified by:
    `getObjectByRef` in interface `DeserializationContext`
  Parameters:
    `href` - is the value of an href attribute (or an Attachment id)
  Returns:
    MessageElement other Object or null

### addObjectById

    public void addObjectById(java.lang.String id,
                              java.lang.Object obj)

  Add the object associated with this id (where id is the value of an id= attribute, i.e. it does not start with #). This routine is called to associate the deserialized object with the id specified on the XML element.
  Specified by:
    `addObjectById` in interface `DeserializationContext`
  Parameters:
    `id` - (id name without the #)
    `obj` - is the deserialized object for this id.

### registerFixup

    public void registerFixup(java.lang.String href,
                              Deserializer dser)

  During deserialization, an element with an href=#id may be encountered before the element defining id=id is read. In these cases, the getObjectByRef method above will return null. The deserializer is placed in a table keyed by href (a fixup table). After the element id is processed, the deserializer is informed of the value so that it can update its target(s) with the value.
  Specified by:
    `registerFixup` in interface `DeserializationContext`
  Parameters:
    `href` - (#id syntax)
    `dser` - is the deserializer of the element

### registerElementByID

    public void registerElementByID(java.lang.String id,
                                    MessageElement elem)

  Register the MessageElement with this id (where id is id= form without the #) This routine is called when the MessageElement with an id is read. If there is a Deserializer in our fixup list (described above), the 'fixup' deserializer is given to the MessageElement. When the MessageElement is completed, the 'fixup' deserializer is informed and it can set its targets.
  Specified by:
    `registerElementByID` in interface `DeserializationContext`
  Parameters:
    `id` - (id name without the #)
    `elem` - is the MessageElement

### registerResolverForID

    public void registerResolverForID(java.lang.String id,
                                      IDResolver resolver)

  Each id can have its own kind of resolver. This registers a resolver for the id.
  Specified by:
    `registerResolverForID` in interface `DeserializationContext`

### getCurrentRecordPos

    public int getCurrentRecordPos()

  Get the current position in the record.
  Specified by:
    `getCurrentRecordPos` in interface `DeserializationContext`

### getStartOfMappingsPos

    public int getStartOfMappingsPos()

  Get the start of the mapping position
  Specified by:
    `getStartOfMappingsPos` in interface `DeserializationContext`

### pushNewElement

    public void pushNewElement(MessageElement elem)

  Push the MessageElement into the recorder
  Specified by:
    `pushNewElement` in interface `DeserializationContext`

### pushElementHandler

    public void pushElementHandler(SOAPHandler handler)

  Management of sub-handlers (deserializers)
  Specified by:
    `pushElementHandler` in interface `DeserializationContext`

### replaceElementHandler

    public void replaceElementHandler(SOAPHandler handler)

  Replace the handler at the top of the stack. This is only used when we have a placeholder Deserializer for a referenced object which doesn't know its type until we hit the referent.
  Specified by:
    `replaceElementHandler` in interface `DeserializationContext`

### popElementHandler

    public SOAPHandler popElementHandler()

  Specified by:
    `popElementHandler` in interface `DeserializationContext`

### startDocument

    public void startDocument()
                       throws org.xml.sax.SAXException

  SAX event handlers
  Overrides:
    `startDocument` in class `org.xml.sax.helpers.DefaultHandler`

### endDocument

    public void endDocument()
                     throws org.xml.sax.SAXException

  endDocument is invoked at the end of the document.
  Overrides:
    `endDocument` in class `org.xml.sax.helpers.DefaultHandler`

### isDoneParsing

    public boolean isDoneParsing()

  Return if done parsing document.
  Specified by:
    `isDoneParsing` in interface `DeserializationContext`

### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                                   java.lang.String uri)
                            throws org.xml.sax.SAXException

  Record the current set of prefix mappings in the nsMappings table. !!! We probably want to have this mapping be associated with the MessageElements, since they may potentially need access to them long after the end of the prefix mapping here. (example: when we need to record a long string of events scanning forward in the document to find an element with a particular ID.)
  Overrides:
    `startPrefixMapping` in class `org.xml.sax.helpers.DefaultHandler`

### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)
                          throws org.xml.sax.SAXException

  Overrides:
    `endPrefixMapping` in class `org.xml.sax.helpers.DefaultHandler`

### setDocumentLocator

    public void setDocumentLocator(org.xml.sax.Locator locator)

  Overrides:
    `setDocumentLocator` in class `org.xml.sax.helpers.DefaultHandler`

### getDocumentLocator

    public org.xml.sax.Locator getDocumentLocator()

### characters

    public void characters(char[] p1,
                           int p2,
                           int p3)
                    throws org.xml.sax.SAXException

  Overrides:
    `characters` in class `org.xml.sax.helpers.DefaultHandler`

### ignorableWhitespace

    public void ignorableWhitespace(char[] p1,
                                    int p2,
                                    int p3)
                             throws org.xml.sax.SAXException

  Overrides:
    `ignorableWhitespace` in class `org.xml.sax.helpers.DefaultHandler`

### processingInstruction

    public void processingInstruction(java.lang.String p1,
                                      java.lang.String p2)
                               throws org.xml.sax.SAXException

  Overrides:
    `processingInstruction` in class `org.xml.sax.helpers.DefaultHandler`

### skippedEntity

    public void skippedEntity(java.lang.String p1)
                       throws org.xml.sax.SAXException

  Overrides:
    `skippedEntity` in class `org.xml.sax.helpers.DefaultHandler`

### startElement

    public void startElement(java.lang.String namespace,
                             java.lang.String localName,
                             java.lang.String qName,
                             org.xml.sax.Attributes attributes)
                      throws org.xml.sax.SAXException

  startElement is called when an element is read. This is the big work-horse. This guy also handles monitoring the recording depth if we're recording (so we know when to stop).
  Overrides:
    `startElement` in class `org.xml.sax.helpers.DefaultHandler`

### endElement

    public void endElement(java.lang.String namespace,
                           java.lang.String localName,
                           java.lang.String qName)
                    throws org.xml.sax.SAXException

  endElement is called at the end tag of an element
  Overrides:
    `endElement` in class `org.xml.sax.helpers.DefaultHandler`

### startDTD

    public void startDTD(java.lang.String name,
                         java.lang.String publicId,
                         java.lang.String systemId)
                  throws org.xml.sax.SAXException

  Specified by:
    `startDTD` in interface `org.xml.sax.ext.LexicalHandler`

### endDTD

    public void endDTD()
                throws org.xml.sax.SAXException

  Specified by:
    `endDTD` in interface `org.xml.sax.ext.LexicalHandler`

### startEntity

    public void startEntity(java.lang.String name)
                     throws org.xml.sax.SAXException

  Specified by:
    `startEntity` in interface `org.xml.sax.ext.LexicalHandler`

### endEntity

    public void endEntity(java.lang.String name)
                   throws org.xml.sax.SAXException

  Specified by:
    `endEntity` in interface `org.xml.sax.ext.LexicalHandler`

### startCDATA

    public void startCDATA()
                    throws org.xml.sax.SAXException

  Specified by:
    `startCDATA` in interface `org.xml.sax.ext.LexicalHandler`

### endCDATA

    public void endCDATA()
                  throws org.xml.sax.SAXException

  Specified by:
    `endCDATA` in interface `org.xml.sax.ext.LexicalHandler`

### comment

    public void comment(char[] ch,
                        int start,
                        int length)
                 throws org.xml.sax.SAXException

  Specified by:
    `comment` in interface `org.xml.sax.ext.LexicalHandler`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 Apache XML Project. All Rights Reserved.